import es, pickle, random, popuplib, os, gamethread

info = es.AddonInfo() 
info.name     = "[D&D] Magic Items" 
info.version  = "Beta 1.0" 
info.url      = "http://dnd-css-mod.wikidot.com/" 
info.basename = "dnditems" 
info.author   = "Arawra"


head = ['Helm', 'Visor', 'Band', 'Hood']
back = ['Cloak', 'Cape', 'Mantle', 'Coat']
chest = ['Chain Shirt', 'Studded Leather', 'Breast Plate', 'Dragon Scale']
hands = ['Gloves', 'Gauntlets', 'Mittens', 'Hand Traps']
feet = ['Boots', 'Greaves', 'Shoes', 'Treads']
weapon = ['Greatsword', 'Longsword', 'Shortsword', 'Bastard Sword', 'Axe', 'Double Axe', 'Orcish Axe', 'Waraxe', 'Mace', 'Club', 'Dagger', 'Spear', 'Javelin', 'Trident']
items = [head, back, chest, hands, feet, weapon]

properties = ['Flaming', 'Shocking', 'Frost', 'of Corrosion', 'Ionu', 'of Lizardkin', 'Wizard\'s', 'Psion\'s', 'of the Cat', 'Astral', 'Viper', 'of Shadow']
pre = ['Flaming', 'Shocking', 'Frost', 'Ionu', 'Wizard\'s', 'Psion\'s', 'Astral', 'Viper']
post = ['of Corrosion', 'of Lizardkin', 'of the Cat', 'of Shadow']

admins = ['STEAM_0:1:45055382']

def load():    
    dnditem_mod = es.ServerVar('[D&D Items]', 'v Beta 1.0')
    dnditem_mod.makepublic()
    
    es.regclientcmd('!itemadmin', 'dnditems/admin', '')
    
    gamble_info = popuplib.create('itemcreateinfo')
    gamble_info.addline('[D&D Items] Info Menu')
    gamble_info.addline('  When you reach 10,000 gold, you have the option')
    gamble_info.addline('to create a magic item. It is a chance to create.')
    gamble_info.addline('The item is stored in one of these slots: head, back,')
    gamble_info.addline('chest, hands, feet, or a weapon. You have a 100%')
    gamble_info.addline('chance of getting an item if you do not have one,')
    gamble_info.addline('but NOT if you already have an item. You can only')
    gamble_info.addline('hold one item of a specific slot at a time.')
    
    gamble_menu = popuplib.create('itemcreatemenu')
    gamble_menu.addline('[D&D Items] Menu')
    gamble_menu.addline('-> 1. Create Magic Item (10,000g)')
    gamble_menu.addline('-> 2. See Current Items')
    gamble_menu.addline('-> 3. See Other Players\' Items')
    gamble_menu.addline('-> 5. How Creating Items Works')
    gamble_menu.addline('-> 7. Upgrade an Existing Item (2,000g/10,000g)')
    gamble_menu.addline('-> 8. Identify an Item (2,000g)')
    gamble_menu.addline('-> 9. Back to Main Menu')
    gamble_menu.addline('-> 0. Close')
    gamble_menu.menuselect = item_select
    
def item_select(userid, choice, popupid):
    steamid = es.getplayersteamid(userid)
    gold = dndPlayerDictionary[userid].getgold()
    if choice == 1:
        if gold >= 10000:
            dndPlayerDictionary[userid].addItem()
        else:
            es.tell(userid, '#multi', '#green[D&D Items] #defaultYou need 10,000 Gold to create an item. You have %s'%gold)
    if choice == 2:
        itemdisplay = popuplib.create('itemdisplay_%s'%userid)
        itemdisplay.addline('Your Items:')
        itemdisplay.addline('Weapon %s'%dndPlayerDictionary[userid].getName('weapon'))
        itemdisplay.addline('Head %s'%dndPlayerDictionary[userid].getName('head'))
        itemdisplay.addline('Back %s'%dndPlayerDictionary[userid].getName('back'))
        itemdisplay.addline('Chest %s'%dndPlayerDictionary[userid].getName('chest'))
        itemdisplay.addline('Hands %s'%dndPlayerDictionary[userid].getName('hands'))
        itemdisplay.addline('Feet %s'%dndPlayerDictionary[userid].getName('feet'))
        itemdisplay.send(userid)
    if choice == 3:
        inspect = popuplib.easymenu('inspect_%s'%userid, None, inspectmenu)
        inspect.settitle('Select a player to inspect their items:')
        for player in es.getUseridList():
            if es.getplayersteamid(player) not in ['BOT', steamid]:
                inspect.addoption(player, es.getplayername(player))
        inspect.send(userid)
    if choice == 5:
        gamble_info.send(userid)
    if choice == 7:
        itemdisplay = popuplib.easymenu('itemdisplay_%s'%userid, None, upgrademenu)
        itemdisplay.settitle('Choose an Item to Upgrade:')
        for x in ['weapon', 'head', 'back', 'chest', 'hands', 'feet']:
            if PlayerDataDictionary[steamid][x]:
                itemdisplay.addoption(x, PlayerDataDictionary[steamid][x].name)
        itemdisplay.send(userid)
    if choice == 8:
        if gold >= 2000:
            itemdisplay = popuplib.easymenu('itemidentify_%s'%userid, None, identifymenu)
            itemdisplay.settitle('Choose an Item to Identify:')
            for x in ['weapon', 'head', 'back', 'chest', 'hands', 'feet']:
                if PlayerDataDictionary[steamid][x]:
                    itemdisplay.addoption(x, PlayerDataDictionary[steamid][x].name)
            itemdisplay.send(userid)
        else:
            es.tell(userid, '#multi', '#green[D&D Items] #defaultYou need 2,000 Gold to identify items. You have %s'%gold)
    if choice == 9:
        es.server.queuecmd('ma_cexec %s "say !menu"'%userid)

def upgrademenu(userid, choice, popupid):
    steamid = es.getplayersteamid(userid)
    item = PlayerDataDictionary[steamid][choice]
    gold = dndPlayerDictionary[userid].getgold()
    if item:
        if item.bonus < 5:
            goldNeeded = 2000
            if item.isWeapon():
                goldNeeded = 10000
            if gold >= goldNeeded:
                es.keysetvalue('dndUsers', steamid, 'gold', int(es.keygetvalue('dndUsers', steamid, 'gold')) - goldNeeded)
                PlayerDataDictionary[steamid][choice].addBonus()
                es.tell(userid, '#multi', '#green[D&D Items] #defaultYou upgraded your item to a #lightgreen%s!'%PlayerDataDictionary[steamid][choice].name)
            else:
               es.tell(userid, '#multi', '#green[D&D Items] #defaultYou need %s Gold to upgrade that item. You have %s'%(goldNeeded, gold))
        else:
            es.tell(userid, '#multi', '#green[D&D Items] #defaultYou already have a +5 item!')
    else:
        es.tell(userid, '#multi', '#green[D&D Items] #defaultYou do not have an item in your %s slot'%choice)
        
def identifymenu(userid, choice, popupid):
    if choice in PlayerDataDictionary[es.getplayersteamid(userid)]:
        gold = dndPlayerDictionary[userid].getgold()
        if gold >= 2000:
            #'Flaming', 'Shocking', 'Frost', 'of Corrosion', 'Ionu', 'of Lizardkin', 'Wizard\'s', 'Psion\'s', 'of the Cat', 'Astral', 'Viper', 'of Shadow'
            prop = PlayerDataDictionary[es.getplayersteamid(userid)][choice].prop
            if prop in ['Flaming', 'Shocking', 'Frost', 'of Corrosion']:
                if 'of ' in prop: prop = str(prop).replace('of ', '')
                if choice == 'weapon':
                    es.tell(userid, '#multi', '#green[D&D Items] #default%s has a 5%% chance of dealing 2-15 damage'%prop)
                else:
                    es.tell(userid, '#multi', '#green[D&D Items] #defaultYou are immune to %s weapons'%prop)
            if prop == 'Ionu':
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 10 bonus hp'%prop)
            if prop == 'of Lizardkin':
                prop = str(prop).replace('of ', '')
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 1HP/3s'%prop)
            if prop == 'Wizard\'s':
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 10 bonus mana'%prop)
            if prop == 'Psion\'s':
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 5 mana/3 sec'%prop)
            if prop == 'of the Cat':
                prop = str(prop).replace("of the ", "")
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 7%% bonus move speed'%prop)
            if prop == 'Astral':
                es.tell(userid, '#multi', '#green[D&D Items] #default%s gives low grav when jumping'%prop)                
            if prop == 'Viper':
                es.tell(userid, '#multi', '#green[D&D Items] #default%s deals 3-15 damage over 3 seconds'%prop)
            if prop == 'of Shadow':
               prop = str(prop).replace('of ', '')
               es.tell(userid, '#multi', '#green[D&D Items] #default%s gives 10 less color'%prop)
            gold -= 2000
            es.keysetvalue('dndUsers', es.getplayersteamid(userid), 'gold', gold)
        else:
            es.tell(userid, '#multi', '#green[D&D Items] #defaultYou need 2,000 Gold to identify items. You have %s'%gold)
        
def inspectmenu(userid, choice, popupid):
    if choice in es.getUseridList():
        itemdisplay = popuplib.create('itemdisplay_%s'%choice)
        itemdisplay.addline('%s\'s Items:'%es.getplayername(choice))
        itemdisplay.addline('Weapon %s'%dndPlayerDictionary[choice].getName('weapon'))
        itemdisplay.addline('Head %s'%dndPlayerDictionary[choice].getName('head'))
        itemdisplay.addline('Back %s'%dndPlayerDictionary[choice].getName('back'))
        itemdisplay.addline('Chest %s'%dndPlayerDictionary[choice].getName('chest'))
        itemdisplay.addline('Hands %s'%dndPlayerDictionary[choice].getName('hands'))
        itemdisplay.addline('Feet %s'%dndPlayerDictionary[choice].getName('feet'))
        itemdisplay.send(userid)

class MagicItem():
    def __init__(self):
        self.bonus = 1
        
        self.prop = random.choice(properties)
        self.item = random.choice(random.choice(items))
        if self.prop in pre:
            self.name = '+%s %s %s'%(self.bonus, self.prop, self.item)
        if self.prop in post:
            self.name = '+%s %s %s'%(self.bonus, self.item, self.prop)
            
        if self.item in weapon:
            self.slot = 'weapon'
        if self.item in head:
            self.slot = 'head'
        if self.item in back:
            self.slot = 'back'
        if self.item in chest:
            self.slot = 'chest'
        if self.item in hands:
            self.slot = 'hands'
        if self.item in feet:
            self.slot = 'feet'
            
    def isWeapon(self):
        if self.slot == 'weapon':
            return 1
        return 0
        
    def addBonus(self):
        if self.bonus < 5:
            self.bonus += 1
            if self.prop in pre:
                self.name = '+%s %s %s'%(self.bonus, self.prop, self.item)
            if self.prop in post:
                self.name = '+%s %s %s'%(self.bonus, self.item, self.prop)
        
class _dndPlayerDictionary(dict):
    def __missing__(self, userid):
        value = self[userid] = DndPlayer(userid)
        return value

    def __delitem__(self, userid):
        if userid in self:
            super(_dndPlayerDictionary, self).__delitem__(userid)
            
dndPlayerDictionary = _dndPlayerDictionary()
            
class _PlayerDataDictionary(dict):
    def __missing__(self, steamid):
        value = self[steamid] = PlayerData()
        #tell(playerinfo_from_userid(self), 'Your class and race have been automatically reset to Human Fighter')
        #msg('%s is new! Give them some help!'%self.name)
        return value

class PlayerData(dict):
    def __init__(self):
        self['weapon'] = self.weapon = None
        self['head'] = self.head = None
        self['back'] = self.back = None
        self['chest'] = self.chest = None
        self['hands'] = self.hands = None
        self['feet'] = self.feet = None
        self['replace'] = self.replace = None

    def __getattr__(self, attr):
        # Redirect to __getitem__
        # Can also use:
        #     return self[attr]
        try:
            return self.__getitem__(attr)
        except KeyError:
            raise AttributeError

    def __setattr__(self, attr, value):
        # Redirect to __setitem__
        # Can also use:
        #     self[attr] = value
        self.__setitem__(attr, value)
        
class DndPlayer():

    def __init__(self, userid):
        self.steamid = es.getplayersteamid(userid)
        self.userid = userid
        PlayerDataDictionary[self.steamid]['name'] = es.getplayername(userid)
        
    def getgold(self):
        gold = es.keygetvalue('dndUsers', self.steamid, 'gold')
        try:
            gold = int(gold)
        except:
            gold = 0
        return gold
        
    def addItem(self):
        es.keysetvalue('dndUsers', self.steamid, 'gold', int(es.keygetvalue('dndUsers', self.steamid, 'gold')) - 10000)
        chance = 75
        slot = 0
        count = 0
        
        for x in ['weapon', 'head', 'back', 'chest', 'hands', 'feet']:
            if not PlayerDataDictionary[self.steamid][x]:
                count += 1
        
        if count == 6:
            chance = 100
        if random.randint(1,100) < chance:
            
            newItem = MagicItem()
            if not PlayerDataDictionary[self.steamid][newItem.slot]:   
                PlayerDataDictionary[self.steamid][newItem.slot] = newItem
                es.tell(self.userid, '#multi', '#green[D&D Items] #defaultYou have created a #lightgreen%s#default! It has been equipped!'%newItem.name)
            else:
                chooseReplace(self.userid, newItem)
        else:
            es.tell(self.userid, '#multi', '#green[D&D Items] #defaultYou destroyed your item during creation!')
            
    def getName(self, name):
        if PlayerDataDictionary[self.steamid][name]:
            return PlayerDataDictionary[self.steamid][name].name
        else:
            return 'No Item'
            
    def getProps(self):
        propList = []
        for x in ['weapon', 'head', 'back', 'chest', 'hands', 'feet']:
            if PlayerDataDictionary[self.steamid][x]:
                propList.append(PlayerDataDictionary[self.steamid][x].prop)
        return propList
        
    def getDefensiveProps(self):
        propList = []
        for x in ['head', 'back', 'chest', 'hands', 'feet']:
            if PlayerDataDictionary[self.steamid][x]:
                propList.append(PlayerDataDictionary[self.steamid][x].prop)
        return propList
        
    def getWeaponProps(self):
        propList = []
        if PlayerDataDictionary[self.steamid]['weapon']:
            propList.append(PlayerDataDictionary[self.steamid]['weapon'].prop)
        return propList
    
def chooseReplace(userid, newItem):
    menu = popuplib.create('replace_%s'%userid)
    menu.addline('Do you wish to replace your ')
    menu.addline(PlayerDataDictionary[es.getplayersteamid(userid)][newItem.slot].name)
    menu.addline('with ')
    menu.addline(newItem.name)
    menu.addline('-> 5. Yes')
    menu.addline('-> 0. No')
    menu.menuselect = replaceChoice
    PlayerDataDictionary[es.getplayersteamid(userid)].replace = newItem
    menu.send(userid)

def replaceChoice(userid, choice, popupid):
    if choice == 5:    
        es.tell(userid, '#multi', '#green[D&D Items] #defaultYou have replaced your #lightgreen%s #defaultwith a #lightgreen%s'%( \
        PlayerDataDictionary[es.getplayersteamid(userid)] \
        [PlayerDataDictionary[es.getplayersteamid(userid)]['replace'].slot].name, \
        PlayerDataDictionary[es.getplayersteamid(userid)].replace.name))
        
        PlayerDataDictionary[es.getplayersteamid(userid)] \
        [PlayerDataDictionary[es.getplayersteamid(userid)]['replace'].slot] = \
        PlayerDataDictionary[es.getplayersteamid(userid)].replace        
        
        PlayerDataDictionary[es.getplayersteamid(userid)].replace = 0
        
def player_spawn(ev):
    player = dndPlayerDictionary[ev['userid']]
    gamethread.delayed(2, itemCheck, player)
    
def itemCheck(player):
    item_names = player.getProps()
            
    #properties = ['Flaming', 'Shocking', 'Frost', 'of Corrosion', 'Ionu', 'of Lizardkin', 'Wizard\'s', 'Psion\'s', 'of the Cat', 'Astral', 'Viper']
    health = int(es.keygetvalue('dndExtra', player.steamid, 'maxhealth'))
    mana = 0
    maxmana = 0
    if int(es.keygetvalue('dndExtra', player.steamid, 'mana')):
        maxmana += int(es.keygetvalue('dndExtra', player.steamid, 'mana'))
    speed = float(es.keygetvalue('dndExtra', player.steamid, 'speed'))
    color = int(es.keygetvalue('dndExtra', player.steamid, 'color'))
    regen = 0
    manaregen = 0
    for x in item_names:
        if x == 'Ionu':
            health += 10
        if x == 'Wizard\'s':
            if maxmana > 0:
                maxmana += 20
        if x == 'of the Cat':
            speed += .07
        if x == 'of Shadow':
            if color < 255:
                color -= 10
            if color < 15:
                color = 15
        if x == 'of Lizardkin':
            regen += 1
        if x == 'Psion\'s':
            manaregen += 5
    es.keysetvalue('dndExtra', player.steamid, 'maxhealth', health)
    es.keysetvalue('dndExtra', player.steamid, 'mana', maxmana)
    es.keysetvalue('dndExtra', player.steamid, 'speed', speed)
    es.setplayerprop(player.userid, 'CBasePlayer.m_iHealth', health)
    es.setplayerprop(player.userid, "CBasePlayer.localdata.m_flLaggedMovementValue", speed)
    prestige = es.keygetvalue('dndUsers', player.steamid, 'prestige')
    race = es.keygetvalue('dndUsers', player.steamid, 'race')
    if prestige != 'rpc3' and race != 'filcher' and color < 255:
        es.server.cmd('est_setplayercolor %s 255 255 255 %s 1'%(player.userid, color))
    if regen:
        regenloop(player.userid, regen)
    if manaregen and maxmana > 0:
        manaregenloop(player.userid, maxmana, manaregen)
        
def regenloop(userid, regen):
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) < int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'maxhealth')):
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + regen)
        if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) > int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'maxhealth')):
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'maxhealth')))
        gamethread.delayedname(3, 'dnditems', regenloop, args=(userid, regen))
        
def manaregenloop(userid, max, regen):
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        if  max > int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'mana')):
            es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'mana', int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'mana')) + regen)
        if  max < int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'mana')):
            es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'mana', max)
        gamethread.delayedname(3, 'dnditems', manaregenloop, args=(userid, max, regen))
        
def player_jump(ev):
    player = dndPlayerDictionary[ev['userid']]    
    if es.keygetvalue('dndUsers', player.steamid, 'race').lower() not in ['halfling', 'tibbit', 'ghoul']:
        items = player.getProps()
        for x in items:
            if x == 'Astral':
                index = es.getindexfromhandle(es.getplayerhandle(player.userid))
                es.entitysetvalue(index, "gravity", .8)
                
def player_hurt(ev):
    if not es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'):
    
        bonus = 0
        if PlayerDataDictionary[ev['es_attackersteamid']]['weapon']:
            bonus = PlayerDataDictionary[ev['es_attackersteamid']]['weapon'].bonus * 3
        attacker_items = dndPlayerDictionary[ev['attacker']].getWeaponProps()
        es
        
        dr = 0
        victim_items = dndPlayerDictionary[ev['userid']].getDefensiveProps()        
        for x in ['head', 'back', 'chest', 'hands', 'feet']:
            if PlayerDataDictionary[ev['es_steamid']][x]:
                dr += PlayerDataDictionary[ev['es_steamid']][x].bonus
                
        damage = int(int(ev['dmg_health']) * float(bonus) / 100) - int(int(ev['dmg_health']) * float(dr) / 100)
        es.setplayerprop(ev['userid'], 'CBasePlayer.m_iHealth', int(es.getplayerprop(ev['userid'], 'CBasePlayer.m_iHealth')) - damage)
            
            
        #properties = ['Flaming', 'Shocking', 'Frost', 'of Corrosion', 'Ionu', 'of Lizardkin', 'Wizard\'s', 'Psion\'s', 'of the Cat', 'Astral', 'Viper', 'of Shadow']
        for x in ['Flaming', 'Shocking', 'Frost', 'of Corrosion']:
            if x in attacker_items:
                if x not in victim_items:                    
                    if random.randint(1,20) == 1:
                        es.server.cmd('point_hurt %s %s %s'%(ev['attacker'], ev['userid'], random.randint(2,15)))
                            
        
        if 'Viper' in attacker_items:
            if 'Viper' not in victim_items:            
                if random.randint(1,20) == 1:
                    es.server.cmd('point_hurt %s %s %s'%(ev['attacker'], ev['userid'], random.randint(1,5)))
                    gamethread.delayed(1, es.server.cmd, args=('point_hurt %s %s %s'%(ev['attacker'], ev['userid'], random.randint(1,5))))
                    gamethread.delayed(2, es.server.cmd, args=('point_hurt %s %s %s'%(ev['attacker'], ev['userid'], random.randint(1,5))))
        
def round_end(ev):
    gamethread.cancelDelayed('dnditems')
    save()
    
def unload():
    save()
    
def save():
    str_path = open(es.getAddonPath('dnditems') + '/database.db', 'wb')
    pickle.dump(PlayerDataDictionary, str_path)
    str_path.close()
    es.msg('#multi', '#green[D&D Items] #defaultItems Saved')
        
PlayerDataDictionary = _PlayerDataDictionary()
str_path = es.getAddonPath('dnditems') + '/database.db'
if os.path.isfile(str_path):
    file_users = open(str_path, 'rb')
    try:
        PlayerDataDictionary = pickle.load(file_users)
    except:
        pass
    file_users.close() 
    es.msg('#multi', '#green[D&D Items] #defaultItems Loaded')
    
    
def admin():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in admins:
        adminMenu = popuplib.easymenu('itemadmin', None, adminPlayerChoice)
        adminMenu.settitle('Choose a player to modify their weapon:')
        for player in PlayerDataDictionary:
            if PlayerDataDictionary[player]['weapon']:
                if PlayerDataDictionary[player]['weapon'].bonus > 1:
                    name = player                    
                    if 'name' in PlayerDataDictionary[player]: name = PlayerDataDictionary[player]['name']
                    adminMenu.addoption(player, name)
        adminMenu.send(userid)
        
def adminPlayerChoice(userid, choice, popupid):
    es.tell(userid, '#multi', '#green[D&D Items] #defaultWeapon bonus was %s'%PlayerDataDictionary[choice]['weapon'].bonus)
    es.tell(userid, '#multi', '#green[D&D Items] #defaultGold was %s'%es.keygetvalue('dndUsers', choice, 'gold'))
    x = PlayerDataDictionary[choice]['weapon'].bonus
    goldReturn = 0
    while x > 1:
        x -= 1
        PlayerDataDictionary[choice]['weapon'].bonus -= 1
        goldReturn += 2000
    es.keysetvalue('dndUsers', choice, 'gold', int(es.keygetvalue('dndUsers', choice, 'gold')) + goldReturn)
    es.tell(userid, '#multi', '#green[D&D Items] #defaultWeapon bonus is %s'%PlayerDataDictionary[choice]['weapon'].bonus)
    es.tell(userid, '#multi', '#green[D&D Items] #defaultGold is %s'%es.keygetvalue('dndUsers', choice, 'gold'))
    